/*Easy Lights v1
By Steven R. Cypherd 5/23/2012
Using a CD74HC164 serial In parallel out shift register
to control 8 Leds with Clock, Data and Master Reset.
*/
#define pClock     2
#define pData      3
#define pMreset    4
#define pButton1   5

int cnt1 = 1;
int cnt2 = 1;
int tmp1 = 0;
int mTime = 750;
byte rMode = 1;
byte lights = 0;
byte litCnt = 1;
byte btn1  = 0;
byte btnState = 0;

void setup(){
  pinMode(pClock, OUTPUT);
  pinMode(pData, OUTPUT);
  pinMode(pMreset, OUTPUT);
  pinMode(pButton1, INPUT);
  Serial.begin(9600);
  randomSeed(analogRead(0));
}

void loop(){
  btn1 = digitalRead(pButton1);
  if (btnState == 0 and btn1 == 1){
    rMode++;
    btnState = 1;
    litCnt = 1;
    cnt1 = 1;
    if(rMode > 3) rMode = 1;
    }
  if(btnState == 1 and btn1 == 0)
    btnState = 0;
  switch(rMode){
    case 1:
      if(cnt1 == 1) mTime = 750;
      cnt1++;//Binary 1 - 32
      lights = cnt1;
      if (cnt1 > 32){
          mTime = 1000;
          cnt1 = 1;
        }
       break;
     case 2:
       if(litCnt == 1){
         lights = 1;
         litCnt++;
         mTime = 50;
         }
       else if(litCnt < 9){
         lights = lights * 2;
         litCnt++;
         }
       else if(litCnt == 9){
         lights = 64;
         litCnt++;
         }
       else if(litCnt < 17){
         lights = lights / 2;
         litCnt++;
         }
       else {
         litCnt = 2;
         lights = 2;
         }
       break;
     default:
       lights = random(300);
       if(mTime != 1000) mTime = 1000;
  }//End switch
  shiftOut(pData, pClock, LSBFIRST, lights);
  delay(mTime);
}//Main Loop
